SystemOrganization addCategory: #'Moe-Model'!
SystemOrganization addCategory: #'Moe-Magritte'!
SystemOrganization addCategory: #'Moe-Seaside'!
SystemOrganization addCategory: #'Moe-Tests'!

!String methodsFor: '*moe' stamp: 'jmck 6/9/2009 10:31'!
asIntegerArray
	^(self allButFirst allButLast subStrings: #($,)) 
			collect: [ :string | Number readFrom: (ReadStream on: string) ]! !

MAPriorityContainer subclass: #MOEmbeddedContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Magritte'!

!MOEmbeddedContainer commentStamp: 'jmck 6/12/2009 14:57' prior: 0!
I exist to point to an MOEmbeddedContainerComponent which saves the model to the DB after commiting the memento to the model.!

!MOEmbeddedContainer methodsFor: 'accessing' stamp: 'jmck 6/9/2009 19:19'!
componentClass
	^MOEmbeddedContainerComponent! !

!Collection methodsFor: '*moe' stamp: 'jmck 6/12/2009 14:02'!
asIntegerArrayString
	"collection elements must respond to id, i.e. MAMappedObject"
	^String streamContents: [ :s | 
		s nextPut: ${;
		nextPutAll: (self collect: [ :each | each id ]) asCommaString;
		nextPut: $} ]! !

MAToOneRelationDescription subclass: #MOEmbeddedObjectDescription
	instanceVariableNames: 'objectClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Magritte'!

!MOEmbeddedObjectDescription commentStamp: 'jmck 6/12/2009 14:57' prior: 0!
I am a convenience description. I return true for isEmbedded ao you don;t have of to send beEmbeddedCollection (but you still have to type EmbeddedCollection!!). I also have a useless objectClass method that is supposed to be a convenience but only serves to confuse issues further lol

I do implement componentClass which returns a nifty lookup component.

The author is still deciding whether or not to toss me like he has the rest of his bloated framework!

!MOEmbeddedObjectDescription methodsFor: 'accessing' stamp: 'jmck 6/11/2009 23:23'!
componentClass
	^MOSelectEmbeddedComponent! !

!MOEmbeddedObjectDescription methodsFor: 'testing' stamp: 'jmck 6/12/2009 14:51'!
isEmbedded
	^true! !

!MOEmbeddedObjectDescription methodsFor: 'accessing' stamp: 'jmck 6/11/2009 23:09'!
objectClass
	"Answer the value of objectClass"

	^ objectClass ifNil: [ self classes first ]! !

!MOEmbeddedObjectDescription methodsFor: 'accessing' stamp: 'jmck 6/12/2009 08:34'!
objectClass: aClass
	"Set the value of objectClass"

	objectClass := aClass.
	classes ifNil: [^ classes := Array with: aClass]. 
	(classes includes: aClass) ifFalse: [ classes := (Array with: aClass) addAll: classes ].! !

!MADescription methodsFor: '*moe' stamp: 'jmck 6/8/2009 20:59'!
beEmbedded
	self propertyAt: #embedded put: true! !

!MADescription methodsFor: '*moe' stamp: 'jmck 6/8/2009 20:59'!
beEmbeddedCollection
	self propertyAt: #embeddedCollection put: true! !

!MADescription methodsFor: '*moe' stamp: 'jmck 6/11/2009 19:51'!
embeddedAccessor: aSelector
	self accessor: (MOEmbeddedAccessor mappedTo: aSelector);
		beEmbedded! !

!MADescription methodsFor: '*moe' stamp: 'jmck 6/11/2009 19:52'!
embeddedCollectionAccessor: aSelector
	self accessor: (MOEmbeddedCollectionAccessor selector: aSelector); beEmbeddedCollection! !

!MADescription methodsFor: '*moe' stamp: 'jmck 6/8/2009 20:59'!
isEmbedded
	^self propertyAt: #embedded ifAbsent: [ false ]! !

!MADescription methodsFor: '*moe' stamp: 'jmck 6/8/2009 20:59'!
isEmbeddedCollection
	^self propertyAt: #embeddedCollection ifAbsent: [ false ]! !

TestCase subclass: #MOEmbeddedObjectTest
	instanceVariableNames: 'object embedded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Tests'!

!MOEmbeddedObjectTest methodsFor: 'as yet unclassified' stamp: 'jmck 6/12/2009 15:38'!
setUp
	object := MOMockObject new 
		privateId: 1;
		field1: 1; 
		field2: 2; 
		field3: 3; 
		embedded: (OrderedCollection 
			with: (MOMockSubObject new
				privateId: 1; 
				field1: 1; 
				field2: 2; 
				field3: 3; 
				yourself)
			with: (MOMockSubObject new 
				privateId: 2; 
				field1: 2; 
				field2: 3; 
				field3: 4; 
				yourself)
			with: (MOMockSubObject new 
				privateId: 3; 
				field1: 3; 
				field2: 4; 
				field3: 5; 
				yourself));
		yourself
			! !

!MOEmbeddedObjectTest methodsFor: 'as yet unclassified' stamp: 'jmck 6/12/2009 15:39'!
testAttributeValueFor: aColumnName! !

MAExternalEditorComponent subclass: #MOSelectEmbeddedComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Seaside'!

!MOSelectEmbeddedComponent commentStamp: 'jmck 6/12/2009 08:41' prior: 0!
An embeddedobject lookup component
Good for one-to-one object lookup, renders the create button to add a new lookup object to the lookup list.!

!MOSelectEmbeddedComponent methodsFor: 'as yet unclassified' stamp: 'jmck 6/11/2009 23:22'!
renderEditorOn: html
	self renderSelectListOn: html..
	super renderSelectButtonOn: html.! !

!MOSelectEmbeddedComponent methodsFor: 'as yet unclassified' stamp: 'jmck 6/11/2009 23:22'!
renderSelectListOn: html
	| instances | 
	(instances := self selected list) isEmpty
		ifFalse: [ 
			html select
				list: instances;
				selected: self value;
				callback: [ :value | value ifNotNil: [ self value: value ] ]
			].
! !

!MOSelectEmbeddedComponent methodsFor: 'as yet unclassified' stamp: 'jmck 6/11/2009 23:22'!
renderViewerOn: html
	self renderEditorOn: html! !

MAMappedObject subclass: #MOEmbeddedObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Model'!

!MOEmbeddedObject commentStamp: 'jmck 6/12/2009 11:10' prior: 0!
Moe is a simple object persistency strategy using Magritte and Roe - Moe!!
The main architectural feature is that Moe make the database "mirror" the Smalltalk objects rather than force the objects to adhere to all sorts of strangulations like pesky foreign key definitions and the like. 

The base class, MOEmbeddedObject,  is a descendant of MAMappedObject. All persisting objects must descend from MOEmbeddedObject and override loadEmbeddedObjectFor: aDescription withId: anId. MODatalistObject and MODatabaseObject are two classes from which you can descend "out of the box". Datalists keep a list of ALL of its instances in a class variable. The latter loads only the objects as they are referenced. 


Describe an embedded object 'Customer' like so:
descriptionCustomer
	^MOEmbeddedObjectDescription new
		objectClass: Customer; 
		embeddedAccessor: #customer;
		label: 'Customer';
		sqlColumnName: 'customer';
		sqlColumnType: 'integer';
		priority: 10;
		yourself
		
When a Moe described objects will have their ID stored in the database in the column where the object should be, and on retrieval from the DB it will be restored with the Smalltalk object. Collections will have an array of integers stored in the DB from which the collection will be restored upon retrieval.

This is pretty lightweight (I think), and is meant only as a means of persistency (read: data backup and restore)
!

MOEmbeddedObject subclass: #MODatabaseObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Model'!

!MODatabaseObject commentStamp: 'jmck 6/11/2009 18:00' prior: 0!
I am like the Datalist object but I don't load all of the insances of me from the database.!

!MODatabaseObject methodsFor: 'persistence' stamp: 'jmck 6/12/2009 14:47'!
loadEmbeddedObjectFor: aDescription withID: anId
	"This can be overridden if you would rather hit the database for each embedded object
	The current implementation uses uses a class variable to store ALL objects from the DB"
	
	 ^ aDescription classes first loadId: anId! !

MOEmbeddedObject subclass: #MODatalistObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Model'!

MODatalistObject class
	instanceVariableNames: 'List'!

!MODatalistObject commentStamp: 'jmck 6/11/2009 17:58' prior: 0!
I am really an example class of one way to maintain the database of objects in the image. I load all the instances of me in a List variable!

MODatalistObject class
	instanceVariableNames: 'List'!

!MODatalistObject class methodsFor: 'persistency' stamp: 'jmck 6/11/2009 09:22'!
list
	
	^List ifNil: 
	
		"["
			 [ (List := OrderedCollection new) addAll: self loadAll ] 
		
		
		"on: Error do: [ :ex | List := nil ] ]"! !

!MODatalistObject methodsFor: 'private-sql' stamp: 'jmck 6/9/2009 19:46'!
insert
	super insert.
	self list add: self.! !

!MODatalistObject methodsFor: 'persistence' stamp: 'jmck 6/9/2009 19:36'!
list
	^self class list! !

!MODatalistObject methodsFor: 'persistence' stamp: 'jmck 6/12/2009 14:46'!
loadEmbeddedObjectFor: aDescription withId: anId
	^ aDescription classes first list detect: [ :each | each id = anId ] ifNone: [ nil ]! !

!MOEmbeddedObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/9/2009 19:19'!
descriptionContainer
	^MOEmbeddedContainer new! !

!MOEmbeddedObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/8/2009 20:44'!
load: aRelation
	^ (super load: aRelation) do: [ :each | each loadEmbedded ].
	! !

!MOEmbeddedObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/9/2009 19:40'!
loadId: anId
	^(super loadId: anId) loadEmbedded! !

!MOEmbeddedObject methodsFor: 'persistence' stamp: 'jmck 6/12/2009 14:10'!
attributeValueFor: aColumnName
	| desc value |
	desc := self description detect: [ :each | each sqlColumnName = aColumnName ] ifNone: [ ^nil ].
	value := self readUsing: desc.
	^desc isEmbedded 
		ifTrue: [ value id ]
		ifFalse: [ 
			desc isEmbeddedCollection 
				ifTrue: [ value asIntegerArrayString ]
				ifFalse: [ value ]]
			! !

!MOEmbeddedObject methodsFor: 'persistence' stamp: 'jmck 6/12/2009 14:03'!
insert
	| descriptions result |
	descriptions := self mappedDescription children
		copyWithout: self class descriptionId.
	result := self relation basicQuery: (self relation
		sqlInsert: (descriptions collect: [ :each | each sqlColumnName  ])
		values: (descriptions collect: [ :each | 
			each isEmbedded 
				ifTrue: [ (self readUsing: each) id ]
				ifFalse: [
					each isEmbeddedCollection
						ifTrue: [ (self readUsing: each) asIntegerArrayString ]
						ifFalse: [ self readUsing: each ]]])) , ';' ,
		(self relation sqlCurrentValue: self class descriptionId sqlColumnName).
	id := result first first.
! !

!MOEmbeddedObject methodsFor: 'persistence' stamp: 'jmck 6/11/2009 17:45'!
loadEmbedded
	self description do: [ :desc |
		desc isEmbedded 
			ifTrue: [ self loadEmbeddedDescription: desc ]
			ifFalse: [
				desc isEmbeddedCollection 
					ifTrue: [ 
						self loadEmbeddedCollectionDescription: desc ]]].
! !

!MOEmbeddedObject methodsFor: 'persistence' stamp: 'jmck 6/12/2009 15:12'!
loadEmbeddedCollectionDescription: aDescription
	"Read the string representation of the integer array returned by postgres, convert it and retrieve the objects
	replacing the string with the ressurected collection"
	
	| ids embeddedObjects |	
	embeddedObjects := aDescription collectionClass new.
	ids := self perform: aDescription accessor selector.
	(ids notNil and: [ ids size > 2 ]) 
			ifTrue: [
				(ids asIntegerArray)
					inject: embeddedObjects
					into: [ :collection :i | 
						collection add: (self loadEmbeddedObjectFor: aDescription withId: i); yourself]].
	aDescription accessor write: embeddedObjects to: self ! !

!MOEmbeddedObject methodsFor: 'persistence' stamp: 'jmck 6/11/2009 18:35'!
loadEmbeddedDescription: aDescription
	| embeddedid |
	(embeddedid := self perform: aDescription accessor next selector) isNil
		ifFalse: [
			aDescription accessor
				write: (self loadEmbeddedObjectFor: aDescription withId: embeddedid)
				to: self ]! !

!MOEmbeddedObject methodsFor: 'persistence' stamp: 'jmck 6/11/2009 18:35'!
loadEmbeddedObjectFor: aDescription withId: anId
	"This can be overridden if you would rather hit the database for each embedded object
	The current implementation uses uses a class variable to store ALL objects from the DB"
	
	 self subclassResponsibility! !

MOEmbeddedObject subclass: #MOMockObject
	instanceVariableNames: 'field1 field2 field3 embedded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Tests'!

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
embedded
	"Answer the value of embedded"

	^ embedded! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
embedded: anObject
	"Set the value of embedded"

	embedded := anObject! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field1
	"Answer the value of field1"

	^ field1! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field1: anObject
	"Set the value of field1"

	field1 := anObject! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field2
	"Answer the value of field2"

	^ field2! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field2: anObject
	"Set the value of field2"

	field2 := anObject! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field3
	"Answer the value of field3"

	^ field3! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field3: anObject
	"Set the value of field3"

	field3 := anObject! !

MOEmbeddedObject subclass: #MOMockSubObject
	instanceVariableNames: 'field1 field2 field3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Tests'!

MAContainerComponent subclass: #MOEmbeddedContainerComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Magritte'!

!MOEmbeddedContainerComponent methodsFor: 'actions' stamp: 'jmck 6/9/2009 11:42'!
save
	self validate ifFalse: [ ^ self ].
	self commit.
	self model save.
	self answer: self model.! !

MAToManyRelationDescription subclass: #MOEmbeddedCollectionDescription
	instanceVariableNames: 'objectClass collectionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Magritte'!

!MOEmbeddedCollectionDescription commentStamp: 'jmck 6/12/2009 14:59' prior: 0!
I am a convenience description. I return true for isEmbeddedCollection so you don't have of to send beEmbeddedCollection (but you still have to type EmbeddedCollection!!). I also have a useless objectClass method that is supposed to be a convenience but only serves to confuse issues further lol

The author is still deciding whether or not to toss me like he has the rest of his bloated framework!

!MOEmbeddedCollectionDescription class methodsFor: 'as yet unclassified' stamp: 'jmck 6/12/2009 15:09'!
defaultCollectionClass
	^OrderedCollection! !

!MOEmbeddedCollectionDescription methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:09'!
collectionClass
	"Answer the value of collectionClass"

	^ collectionClass ifNil: [ self class defaultCollectionClass ]! !

!MOEmbeddedCollectionDescription methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:08'!
collectionClass: anObject
	"Set the value of collectionClass"

	collectionClass := anObject! !

!MOEmbeddedCollectionDescription methodsFor: 'testing' stamp: 'jmck 6/12/2009 14:52'!
isEmbeddedCollection
	^true! !

!MOEmbeddedCollectionDescription methodsFor: 'accessing' stamp: 'jmck 6/11/2009 23:26'!
objectClass
	"Answer the value of objectClass"

	^ objectClass ifNil: [ self classes first ]! !

!MOEmbeddedCollectionDescription methodsFor: 'accessing' stamp: 'jmck 6/11/2009 23:24'!
objectClass: anObject
	"Set the value of objectClass"

	objectClass := anObject! !
